unit TexEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, ExtCtrls, ImgList, ComCtrls;

type
  TTexEditForm = class(TForm)
    TextureGrid: TStringGrid;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    Panel9: TPanel;
    Panel10: TPanel;
    Panel11: TPanel;
    Panel12: TPanel;
    Panel13: TPanel;
    Panel14: TPanel;
    Panel15: TPanel;
    Panel16: TPanel;
    Label1: TLabel;
    ZoomInBtn: TButton;
    ZoomOutBtn: TButton;
    GridChk: TCheckBox;
    ImageList1: TImageList;
    ListView1: TListView;
    ListView2: TListView;
    ImageList2: TImageList;
    NextBtn: TButton;
    procedure NextBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TextureGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure GridChkClick(Sender: TObject);
    procedure ZoomInBtnClick(Sender: TObject);
    procedure ZoomOutBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  TexEditForm: TTexEditForm;

implementation

uses main;

{$R *.dfm}

const
{  CurPal: Array [0..15] of TColor = (
{  $00000000, $004A2400, $00946D4A, $00DEBA94,
  $00FFDFDE, $00002421, $0000494A, $00FF6D21,
  $0000004A, $0000246B, $004A92FF, $00214994,
  $00BDFFFF, $000024DE, $0021924A, $00000000);}
  CurPal: Array [0..15] of TColor = (
  $00E000E0, $00402000, $00806040, $00c0a080,
  $00e0c0c0, $00002020, $00004040, $00e06020,
  $00000040, $00002060, $004080e0, $00204080,
  $00a0e0e0, $000020c0, $00208040, $00000000);

var
  ROffs,C: LongInt;
  TextureBuf: Array [0..511] of Byte;
  Texture: Array [0..31,0..31] of Byte;

function GetClr1(B: Byte): Byte;
asm
  shr b,4
  mov result,b
end;

function GetClr2(B: Byte): Byte;
asm
  shl b,4
  shr b,4
  mov result,b
end;

procedure TTexEditForm.FormCreate(Sender: TObject);
begin
  ROffs:=0;
end;

procedure TTexEditForm.FormShow(Sender: TObject);
begin
  Panel1.Color:=CurPal[0];
  Panel2.Color:=CurPal[1];
  Panel3.Color:=CurPal[2];
  Panel4.Color:=CurPal[3];
  Panel5.Color:=CurPal[4];
  Panel6.Color:=CurPal[5];
  Panel7.Color:=CurPal[6];
  Panel8.Color:=CurPal[7];
  Panel9.Color:=CurPal[8];
  Panel10.Color:=CurPal[9];
  Panel11.Color:=CurPal[10];
  Panel12.Color:=CurPal[11];
  Panel13.Color:=CurPal[12];
  Panel14.Color:=CurPal[13];
  Panel15.Color:=CurPal[14];
  Panel16.Color:=CurPal[15];
end;

procedure TTexEditForm.GridChkClick(Sender: TObject);
begin
  if not GridChk.Checked then
    TextureGrid.Options := TextureGrid.Options - [goVertLine, goHorzLine]
  else
    TextureGrid.Options := TextureGrid.Options + [goVertLine, goHorzLine]
end;

procedure TTexEditForm.NextBtnClick(Sender: TObject);
var
  I,J,L: Word;
  K: Word;
  CurTile,Tile1,Tile2,Tile3,Tile4,Tile5,Tile6,Tile7,Tile8: TBitmap;
begin
  ROM.Seek(MainForm.TexTilesOffset,soFromBeginning);
  for L:= 0 to 246 do
  begin
    K:=0;
    ROM.ReadBuffer(TextureBuf,SizeOf(TextureBuf));
    CurTile:=TBitmap.Create;
    CurTile.Width:=32;
    CurTile.Height:=32;
    for I := 0 to 15 do
    begin
      for J := 0 to 31 do
      begin
  //      Texture[I,J*2]:=GetClr1(TextureBuf[K]);
  //      Texture[I,J*2+1]:=GetClr2(TextureBuf[K]);
        Texture[I*2,J]:=GetClr1(TextureBuf[K]);
        CurTile.Canvas.Pixels[I*2,J]:=CurPal[GetClr1(TextureBuf[K])];
        Texture[I*2+1,J]:=GetClr2(TextureBuf[K]);
        CurTile.Canvas.Pixels[I*2+1,J]:=CurPal[GetClr2(TextureBuf[K])];
  //      Texture[I,J+1]:=GetClr2(TextureBuf[K]);
        Inc(K);
      end
    end;
    ImageList1.Add(CurTile,nil);
//  ListView1.AddItem(IntToStr(L),MainForm);
//  ListView1.Items.Item[L].ImageIndex:=L;
    CurTile.Free;
  end;
//  ROM.Seek(MainForm.E1TexOffset,soFromBeginning);
//  ROM.ReadBuffer(TexArray,SizeOf(TexArray));
  //  ROffs:=ROffs+4096;
  //  OffsEdit.Text:=IntToHex(ROffs,8);
  for L := 0 to 255 do
  begin
  CurTile:=TBitmap.Create;
  CurTile.Width:=128;
  CurTile.Height:=64;
  Tile1:=TBitmap.Create;
  Tile2:=TBitmap.Create;
  Tile3:=TBitmap.Create;
  Tile4:=TBitmap.Create;
  Tile5:=TBitmap.Create;
  Tile6:=TBitmap.Create;
  Tile7:=TBitmap.Create;
  Tile8:=TBitmap.Create;
  ImageList1.GetBitmap(Hi(MainForm.CE.TexDefs[L,0]),Tile1);
  ImageList1.GetBitmap(Hi(MainForm.CE.TexDefs[L,1]),Tile2);
  ImageList1.GetBitmap(Hi(MainForm.CE.TexDefs[L,2]),Tile3);
  ImageList1.GetBitmap(Hi(MainForm.CE.TexDefs[L,3]),Tile4);
  ImageList1.GetBitmap(Hi(MainForm.CE.TexDefs[L,4]),Tile5);
  ImageList1.GetBitmap(Hi(MainForm.CE.TexDefs[L,5]),Tile6);
  ImageList1.GetBitmap(Hi(MainForm.CE.TexDefs[L,6]),Tile7);
  ImageList1.GetBitmap(Hi(MainForm.CE.TexDefs[L,7]),Tile8);
  for I := 0 to 31 do
    for J := 0 to 31 do
    begin
      CurTile.Canvas.Draw(0,0,Tile1);
      CurTile.Canvas.Draw(0,32,Tile2);
      CurTile.Canvas.Draw(32,0,Tile3);
      CurTile.Canvas.Draw(32,32,Tile4);
      CurTile.Canvas.Draw(64,0,Tile5);
      CurTile.Canvas.Draw(64,32,Tile6);
      CurTile.Canvas.Draw(96,0,Tile7);
      CurTile.Canvas.Draw(96,32,Tile8);
{      CurTile.Canvas.Pixels[J,I]:=Tile1.Canvas.Pixels[J,I];
      CurTile.Canvas.Pixels[J,I+32]:=Tile2.Canvas.Pixels[J,I];
      CurTile.Canvas.Pixels[J+32,I]:=Tile3.Canvas.Pixels[J,I];
      CurTile.Canvas.Pixels[J+32,I+32]:=Tile4.Canvas.Pixels[J,I];
      CurTile.Canvas.Pixels[J+64,I]:=Tile5.Canvas.Pixels[J,I];
      CurTile.Canvas.Pixels[J+64,I+32]:=Tile6.Canvas.Pixels[J,I];
      CurTile.Canvas.Pixels[J+96,I]:=Tile7.Canvas.Pixels[J,I];
      CurTile.Canvas.Pixels[J+96,I+32]:=Tile8.Canvas.Pixels[J,I];}
    end;
  Tile1.Free;
  Tile2.Free;
  Tile3.Free;
  Tile4.Free;
  Tile5.Free;
  Tile6.Free;
  Tile7.Free;
  Tile8.Free;
  ImageList2.Add(CurTile,nil);
  ListView2.AddItem(IntToHex(L,2),MainForm);
  ListView2.Items.Item[L].ImageIndex:=L;
  CurTile.Free;
  end;
  TextureGrid.Refresh
end;

procedure TTexEditForm.TextureGridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
  TextureGrid.Canvas.Brush.Style:=bsSolid;
  TextureGrid.Canvas.Brush.Color:=CurPal[Texture[ACol,ARow]];
  TextureGrid.Canvas.FillRect(Rect);
end;

procedure TTexEditForm.ZoomInBtnClick(Sender: TObject);
begin
  if TextureGrid.DefaultColWidth<8 then
  begin
    TextureGrid.DefaultColWidth:=TextureGrid.DefaultColWidth+1;
    TextureGrid.DefaultRowHeight:=TextureGrid.DefaultRowHeight+1
  end;
end;

procedure TTexEditForm.ZoomOutBtnClick(Sender: TObject);
begin
  if TextureGrid.DefaultColWidth>1 then
  begin
    TextureGrid.DefaultColWidth:=TextureGrid.DefaultColWidth-1;
    TextureGrid.DefaultRowHeight:=TextureGrid.DefaultRowHeight-1
  end;
end;

end.
